
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "uip/uip.h"
#include "uip/uip_arp.h"
#include "hardware/enc28j60.h"
#include "apps/uip-app.h"



#define BUF ((struct uip_eth_hdr *)&uip_buf[0])

/*---------------------------------------------------------------------------*/
int main(void) {
  uip_ipaddr_t ipaddr;

  uip_init();
  uip_arp_init();
  memcpy_P(uip_ethaddr.addr, PSTR("\xAC\xDE\x48\xFD\x0F\xD0"), 6);
  uip_ipaddr(ipaddr, 192,168,69,21);
  uip_sethostaddr(ipaddr);
  uip_ipaddr(ipaddr, 255,255,255,0);
  uip_setnetmask(ipaddr);

  enc28j60Init();
  uipAppInit();

  while(1) {
    uip_len = enc28j60PacketReceive(UIP_CONF_BUFFER_SIZE, &uip_buf[0]);
    if(uip_len > 0) {
      if(BUF->type == htons(UIP_ETHTYPE_IP)) {
	uip_arp_ipin();
	uip_input();
	if(uip_len > 0) {
	  uip_arp_out();
	  enc28j60PacketSend(uip_len,&uip_buf[0]);
	}
      } else if(BUF->type == htons(UIP_ETHTYPE_ARP)) {
	uip_arp_arpin();
	if(uip_len > 0) {
	  enc28j60PacketSend(uip_len,&uip_buf[0]);
	}
      }
    }
  }
  return 0;
}
/*---------------------------------------------------------------------------*/
